]> git.pld-linux.org Git - packages/rpm-build-macros.git/blame_incremental - rpm.macros
- in fact, all pear packages are irrelevant
[packages/rpm-build-macros.git] / rpm.macros
... / ...
CommitLineData
1# $Revision$, $Date$
2# PLD Linux rpm macros.
3# <http://www.pld-linux.org/>
4
5# can be used by builder script to check for version
6%rpm_build_macros %(R="$Revision$"; RR="${R##: }"; echo ${RR%%?})
7
8%epoch 0
9%x8664 x86_64 amd64 ia32e
10%arm armv3l armv4b armv4l armv5teb armv5tel
11
12# kernel compiler
13%kgcc %{__cc}
14%kgcc_package gcc
15
16# compiler version
17%cc_version %{expand:%%global cc_version %(%{__cc} -dumpversion || echo ERROR)}%cc_version
18%cxx_version %{expand:%%global cxx_version %(%{__cxx} -dumpversion || echo ERROR)}%cxx_version
19
20%__rm /bin/rm --interactive=never
21
22# Build system path macros.
23%__autoconf autoconf %{?debug:-Wall}
24%__automake automake -a -c -f --foreign
25%__autopoint autopoint --force
26
27# add parallel build flags: -jN
28#
29# if you want to disable parallel build do:
30# echo '%_smp_mflags %{nil}' >> ~/.rpmmacros
31#
32%__make /usr/bin/make %{?_smp_mflags}
33%__scons /usr/bin/scons %{?_smp_mflags}
34%__waf /usr/bin/waf %{?_smp_mflags}
35%__cmake /usr/bin/cmake
36
37%_smp_mflags %(_NCPUS=$(/usr/bin/getconf _NPROCESSORS_ONLN); \\\
38 [ "$_NCPUS" -gt 1 ] && echo "-j$(($_NCPUS * 2))")
39
40%__gettextize { \
41 if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
42 gettextize --copy --force --no-changelog; \
43 else \
44 gettextize --copy --force --no-changelog --intl; \
45 fi; \
46 if [ ! -f po/Makevars ]; then \
47 cp -f po/Makevars{.template,}; \
48 fi; \
49}
50
51%__glib_gettextize glib-gettextize --copy --force
52%__gnome_doc_common gnome-doc-common --copy
53%__gnome_doc_prepare gnome-doc-prepare --copy --force
54%__gtkdocize gtkdocize --copy
55%__intltoolize intltoolize --copy --force
56%__libtoolize libtoolize --copy --force --install
57
58# topdir is where builder script lives,
59# fallback to old style if SPECS/SOURCES dirs were found.
60%_topdir %{expand:%%global _topdir %(
61 if [ -d SPECS -a -d SOURCES ]; then
62 # old style rpmdir: in topdir
63 pwd
64 elif [ -d ../SPECS -a -d ../SOURCES ]; then
65 # old style rpmdir: in subdir
66 cd ..; pwd
67 elif [ -d $HOME/rpm/SPECS -a -d $HOME/rpm/SOURCES ]; then \
68 # if old style rpm dir exist, go with it
69 echo $HOME/rpm; \
70 elif [ -x ../builder -a ! -d ../builder ]; then
71 # relative new style rpmdir: in package dir
72 cd ..; pwd
73 elif [ -x builder -a ! -d builder ]; then
74 # relative new style rpmdir: in packages
75 pwd
76 elif [ -x packages/builder -a ! -d packages/builder ]; then
77 # relative new style rpmdir: packages dir in current dir
78 cd packages; pwd
79 else
80 # fallback to new style rpmdir
81 echo $HOME/rpm/packages
82 fi; \
83)}%_topdir
84
85# if %{_topdir}/SPECS exists, it's old style structure
86%_specdir %{expand:%%global _specdir %([ ! -d %{_topdir}/SPECS ] && echo %{_topdir}/%{name} || echo %{_topdir}/SPECS)}%_specdir
87%_sourcedir %{expand:%%global _sourcedir %([ ! -d %{_topdir}/SOURCES ] && echo %{_specdir} || echo %{_topdir}/SOURCES)}%_sourcedir
88
89# BUILD/RPMS/SRPMS are one same level by default as packages dir, if these exist
90# if they don't exist assume we are having custom topdir (which is not named as
91# "packages", i.e ~/rpm/kde/{kdelibs,BUILD/RPMS/SRPMS})
92# NOTE: readlink fails if some parent dir is not readable (/home/services/builder for example can't read /home/services), therfore the extra echo
93%_builddir %{expand:%%global _builddir %(if [ -d %{_topdir}/BUILD ]; then echo %{_topdir}/BUILD; else readlink -m %{_topdir}/../BUILD || echo %{_topdir}/../BUILD; fi)}%_builddir
94%_rpmdir %{expand:%%global _rpmdir %(if [ -d %{_topdir}/RPMS ]; then echo %{_topdir}/RPMS; else readlink -m %{_topdir}/../RPMS || echo readlink -m %{_topdir}/../RPMS; fi)}%_rpmdir
95%_srcrpmdir %{expand:%%global _srcrpmdir %(if [ -d %{_topdir}/SRPMS ]; then echo %{_topdir}/SRPMS; else readlink -m %{_topdir}/../SRPMS || echo readlink -m %{_topdir}/../SRPMS; fi)}%_srcrpmdir
96
97# The number of cvs changelog entries kept when building package.
98%_buildchangelogtruncate 20
99
100%dependencytracking %{nil}
101
102# Relations between package names that cause dependency loops
103# with legacy packages that cannot be fixed. Relations are
104# specified as
105# p>q
106# where package p has a Requires: on something that package q Provides:
107#
108# XXX Note: that there cannot be any whitespace within the string "p>q",
109# and that both p and q are package names (i.e. no version/release).
110%_dependency_whiteout %{nil}
111
112#-----------------------------------------------------------------
113#
114# (re)definition of %{rpm*flags} with %filterout_* support
115# BuildRequires: awk
116# BuildRequires: rpmbuild(macros) >= 1.315
117#
118# Flags specified in %filterout_* are removed from %rpm*flags, exactly:
119# %rpmcflags = %optflags - %filterout - %filterout_c - %filterout_ld
120# %rpmcxxflags = %optflags - %filterout - %filterout_cxx - %filterout_ld
121# %rpmcppflags = %optcppflags - %filterout - %filterout_cpp - %filterout_ld
122# %rpmldflags = %optldflags - %filterout_ld
123#
124# Regular expressions are supported, but to avoid some character be treated
125# as regular expression it must be escaped twice.
126
127%filter_out \
128 for (i = 1; i in I; i++) { A=0; \
129 for (f in F) { \
130 if (I[i] ~ "^" F[f] "$") A=1; \
131 }; \
132 if (!A) printf(I[i] FS); \
133 }
134
135%rpmcflags %(awk 'BEGIN {
136 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
137 split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
138 %{filter_out}
139}')
140
141%rpmcxxflags %(awk 'BEGIN {
142 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
143 split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
144 %{filter_out}
145}')
146
147%rpmcppflags %(awk 'BEGIN {
148 split("%{?debug:%debugcppflags}%{!?debug:%optcppflags}%{?debuginfocppflags}",I);
149 split("%{?filterout} %{?filterout_cpp} %{?filterout_cpp}",F);
150 %{filter_out}
151}')
152
153%rpmldflags %(awk 'BEGIN {
154 split("%{?optldflags}",I);
155 split("%{?filterout_ld}",F)
156 %{filter_out}
157}')
158
159# rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
160# but, don't use it, better use gcc as linker
161%ld_rpmldflags %(awk 'BEGIN {
162 split("%{rpmldflags}",F);
163 for (f in F) {
164 s = F[f];
165 if (s ~ /^-Wl,/) {
166 s = substr(s,5);
167 gsub(/,/," ",s);
168 };
169 printf(s FS);
170 };
171}')
172
173#-----------------------------------------------------------------
174#
175# Generate a command which cleans environment, leaving only the
176# most important variables.
177# If any spec requires any additional environment it should
178# redefine %_preserve_env in following manner:
179#
180# # ADDITIONAL_VAR is required because [a good reason here]
181# %define _preserve_env ADDITIONAL_VAR
182
183%_preserve_env_base PATH HOME TMP TMPDIR SSH_AUTH_SOCK
184
185# "env -i" must end in first line of expaned macros because it's used as first line of shell script (#! env...)
186%_clean_env %{!?_preserve_env:%global _preserve_env %{nil}}%{expand:%%global _preserve_env %{_preserve_env} %_preserve_env_base} env -i %(awk -vq="'" -vqq="\\"'\\"" -vq2q="'\\"'" 'BEGIN {
187 split("%{?_preserve_env}", P);
188 for (i in P) {
189 p = P[i];
190 if (!ENVIRON[p] || d[p]) {
191 continue;
192 }
193 d[p] = 1;
194 split(ENVIRON[p], V, "");
195 val = p "=";
196 for (j = 1; j in V; j++) {
197 v = V[j];
198 if (v == q)
199 v = qq;
200 else if (v == "\\"")
201 v = q2q;
202 else if (v == "\\\\")
203 v = "\\\\\\\\";
204 else
205 gsub("[^a-zA-Z0-9/:._-]", "\\"&\\"", v);
206 val = val "" v;
207 }
208 printf(val " ");
209 }
210}')
211
212#-----------------------------------------------------------------
213%configure2_13 { \
214 if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
215 LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
216 CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
217 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
218 FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
219 FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
220 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" ; export CPPFLAGS ; \
221 %{?__cc:CC="%{__cc}" ; export CC ; } \
222 %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
223 %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
224 --host=%{_target_platform} \
225 --prefix=%{_prefix} \
226 --exec-prefix=%{_exec_prefix} \
227 --bindir=%{_bindir} \
228 --sbindir=%{_sbindir} \
229 --sysconfdir=%{_sysconfdir} \
230 --datadir=%{_datadir} \
231 --includedir=%{_includedir} \
232 --libdir=%{_libdir} \
233 --libexecdir=%{_libexecdir} \
234 --localstatedir=%{_localstatedir} \
235 --sharedstatedir=%{_sharedstatedir} \
236 --mandir=%{_mandir} \
237 --infodir=%{_infodir} \
238 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
239 %{dependencytracking} \
240}
241
242%cmake \
243CC="%{__cc}" \\\
244CXX="%{__cxx}" \\\
245CFLAGS="%{rpmcflags}" \\\
246CXXFLAGS="%{rpmcxxflags}" \\\
247LDFLAGS="%{rpmldflags}" \\\
248%{__cmake} \\\
249 -DCMAKE_INSTALL_PREFIX=%{_prefix} \\\
250 -DCMAKE_BUILD_TYPE=%{!?debug:Release}%{?debug:Debug} \\\
251%if "%{_lib}" == "lib64" \
252 -DLIB_SUFFIX=64 \\\
253%endif \
254%{nil}
255
256%scons { \
257%{__scons} \
258 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
259 CFLAGS="${CFLAGS:-%rpmcflags}" \
260 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
261 FFLAGS="${FFLAGS:-%rpmcflags}" \
262 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
263 %{?__cc:CC="%{__cc}"} \
264 %{?__cxx:CXX="%{__cxx}"} \
265 libsuffix=%{_lib} \
266 prefix=%{_prefix} \
267}
268
269# waf. see waf.spec
270%waf { \
271CC="%{__cc}" \
272CXX="%{__cxx}" \
273CPP="%{__cpp}" \
274CFLAGS="%{rpmcflags}" \
275CXXFLAGS="%{rpmcxxflags}" \
276%{__waf} \
277}
278
279#----------------------------------------------------------------
280#%configure_cache 0
281%configure_cache_file %{buildroot}.configure.cache
282
283%configure {./configure \
284 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
285 CFLAGS="${CFLAGS:-%rpmcflags}" \
286 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
287 FFLAGS="${FFLAGS:-%rpmcflags}" \
288 FCFLAGS="${FCFLAGS:-%rpmcflags}" \
289 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
290 %{?__cc:CC="%{__cc}"} \
291 %{?__cxx:CXX="%{__cxx}"} \
292 --host=%{_target_platform} \
293 --build=%{_target_platform} \
294 --prefix=%{_prefix} \
295 --exec-prefix=%{_exec_prefix} \
296 --bindir=%{_bindir} \
297 --sbindir=%{_sbindir} \
298 --sysconfdir=%{_sysconfdir} \
299 --datadir=%{_datadir} \
300 --includedir=%{_includedir} \
301 --libdir=%{_libdir} \
302 --libexecdir=%{_libexecdir} \
303 --localstatedir=%{_localstatedir} \
304 --sharedstatedir=%{_sharedstatedir} \
305 --mandir=%{_mandir} \
306 --infodir=%{_infodir} \
307 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
308 %{dependencytracking} \
309 %{?configure_cache:--cache-file=%{configure_cache_file}} \
310}
311
312# Simple macros to simplify adding bconded options to configure scripts.
313# Each macro requires bcond name and accepts optional option name, if option
314# isn't specified bcond name is used as option name. Options returning
315# --with and --enable also allow third argument which will be added as value
316# ( --with-option=value or --enable-option=value ) in case or positive
317# condition, but won't be added otherwise ( nothing or just --disable-option ).
318
319# Requirements:
320# BuildRequires: rpmbuild(macros) >= 1.527
321
322# Usage example:
323# %{__enable bcond} - returns --enable-bcond iff build condition is set
324# %{__disable bcond option} - returns --enable-option iff bcond is not set
325# %{__enable_disable bcond option value} - returns --enable-option=value if
326# bcond is set, returns --disable-option otherwise
327
328# expand bconds to --enable-something and --disable-something
329%__enable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
330%__disable() %{expand:%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
331%__enable_disable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
332
333# same as above, but condition inverted
334%__enable_unless() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
335%__disable_if() %{expand:%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
336%__enable_disable_not() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
337
338# expand bconds to --with-something and --without-something
339%__with() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
340%__without() %{expand:%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
341%__with_without() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
342
343# same as above, but condition inverted
344%__with_unless() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
345%__without_if() %{expand:%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
346%__with_without_not() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
347
348#-----------------------------------------------------------------
349
350# overload to insert debuginfo package
351%prep \
352%if 0%{?_enable_debug_packages}\
353%{debug_package}\
354%endif\
355%%prep\
356%{nil}
357
358# Location of autoconf macros
359%_aclocaldir %{expand:%%global _aclocaldir %(aclocal --print-ac-dir 2>/dev/null || echo ERROR)}%_aclocaldir
360
361# Location of omf files
362%_omf_dest_dir %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir || echo ERROR)}%_omf_dest_dir
363
364# Location of pkgconfig files
365%_pkgconfigdir /usr/%{_lib}/pkgconfig
366# noarch pkgconfig files
367%_npkgconfigdir /usr/share/pkgconfig
368
369# Location of desktop files
370%_desktopdir /usr/share/applications
371%_applnkdir ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
372
373# Location of pixmaps for applnk/desktop files
374%_pixmapsdir /usr/share/pixmaps
375
376# Location of themable icons for applnk/desktop files
377%_iconsdir /usr/share/icons
378
379# Location of fonts directories
380%_fontsdir /usr/share/fonts
381
382# Location of Gtk and associated libraries documentation
383%_gtkdocdir %{_defaultdocdir}/gtk-doc/html
384
385# Location of KDE documentation
386%_kdedocdir %{_defaultdocdir}/kde/HTML
387
388# unsermake script
389%__unsermake /usr/share/unsermake/unsermake
390
391# Current date
392%date %(LC_ALL=C date +"%a %b %d %Y")
393
394# Example files, programs, scripts...
395%_examplesdir /usr/src/examples
396
397# Alternative kernel type/version
398%_alt_kernel %{nil}%{?alt_kernel:-%{?alt_kernel}}
399
400# The directory holding Linux kernel sources
401%_kernelsrcdir /usr/src/linux%{_alt_kernel}
402
403# SysV-style initscripts dir
404%_initddir /etc/rc.d/init.d
405
406# If non-empty "debug" macro defined, add "dbg" suffix to release number
407%_rpmfilename %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
408
409# Bootstrap release macros.
410# Usage:
411# %bcond_with bootstrap
412# Release: %{bootstrap_release 1}
413#
414# Package will have release 1 if built normally,
415# and release 0.zzz.bootstrap if built with bootstrap
416%bootstrap_release() %{!?with_bootstrap:%{1}%{?2:.%{2}}}%{?with_bootstrap:%{!?2:%(expr %{1} - 1)}%{?2:%{1}.%(expr %{2} - 1)}.zzz.bootstrap}
417
418# -n drm to generate kernel%{_alt_kernel}-drm dependency
419%releq_kernel(n:) %{expand:%%global releq_kernel %(R=$(LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}} = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel
420%releq_kernel_up(n:) %{expand:%%global releq_kernel_up %(R=$(LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}}-up = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_up
421%releq_kernel_smp(n:) %{expand:%%global releq_kernel_smp %(R=$(LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}}-smp = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_smp
422
423# -s post to generate Requires(post) dependency
424%requires_releq_kernel(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel
425%requires_releq_kernel_up(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel_up
426%requires_releq_kernel_smp(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel_smp
427
428# Requires name = version-release
429%requires_releq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to -r %1 %1}}}
430# Requires: name = version
431%requires_eq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to %1 %1}}}
432# Requires: name = version (version based on querying package %2)
433%requires_eq_to(r) %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
434
435# Requires: name >= version
436%requires_ge() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_ge_to %1 %1}}}
437# Requires: name >= version (version based on querying package %2)
438%requires_ge_to(r) %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 >= %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
439
440%apache_modules_api %{expand:%%global apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)}%apache_modules_api
441
442# kernel version-release handling
443%__kernel_ver %{expand:%%global __kernel_ver %( \\
444 Z=$([ -f '%{_kernelsrcdir}/include/generated/utsrelease.h' ] && awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/{linux/version,generated/utsrelease}.h 2>/dev/null || awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/linux/{version,utsrelease}.h 2>/dev/null); \\
445 Z=${Z:-$(awk -F' = ' '/^VERSION/{v=$2} /^PATCHLEVEL/{p=$2} /^SUBLEVEL/{s=$2} /^EXTRAVERSION/{e=$2} END {printf("%d.%d.%d%s", v, p, s, e)}' %{_kernelsrcdir}/Makefile 2>/dev/null)}; \\
446 echo ${Z:-ERROR}; \\
447)}%__kernel_ver
448
449%__kernel_rel %{expand:%%global __kernel_rel %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rel
450%__kernel_rpmvr %{expand:%%global __kernel_rpmvr %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{V}-%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rpmvr
451%_kernel_ver %{expand:%%global _kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}}%_kernel_ver
452%_kernel_ver_str %{expand:%%global _kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')}%_kernel_ver_str
453
454# `uname -r` to be used in @release field
455%_kernel_vermagic %{expand:%%global _kernel_vermagic %(echo %{_kernel_ver} | sed -e 's/-/_/g')}%_kernel_vermagic
456
457# sgml macros
458%xmlcat_add() /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
459%xmlcat_del() /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
460%xmlcat_add_rewrite /usr/bin/xmlcatalog --noout --add rewriteSystem
461%xmlcat_create() /usr/bin/xmlcatalog --noout --create %1 ;
462%sgmlcat_add() /usr/bin/install-catalog --add %1 %2 > /dev/null ;
463%sgmlcat_del() /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
464%docbook_sgmlcat_fix() { for l in \
465'' \
466' -- default decl --' \
467'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
468' -- hacks for opensp --' \
469'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
470'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
471'' \
472; do echo $l; done >> %1 \
473}
474
475# vim - "
476
477# minimum file size needed for compressed documents.
478# just smaller files than this get larger when compressed.
479# some stats:
480# - 0 byte file compressed was 25 bytes .gz
481# - 39 byte file was compressed as 57
482# - with test/test.spec@man 158 byte file was compressed also 158
483%_min_compress_bytes 159
484
485#-----------------------------------------------------------------
486# find and gzip all files in %{_mandir} and %{infodir}
487#
488# Requires: xargs, find
489#
490#%no_install_post_compress_docs 1
491%__spec_install_post_compress_docs { \
492%{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
493 for i in /usr/share/man /usr/X11R6/man; do \
494 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
495 echo "Compress man pages: $i"; \
496 find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
497 find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
498 find $RPM_BUILD_ROOT$i -type l | while read a; do \
499 m=$(readlink $a); \
500 rm -f $a; \
501 echo .so ${m##*/} > $a; \
502 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: ${m##*/}"; \
503 done; \
504 find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
505 fi; \
506 done; \
507 if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
508 echo "Compress info pages: %{_infodir}"; \
509 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
510 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
511 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
512 fi; \
513}; __spec_install_post_compress_docs } }
514
515#-----------------------------------------------------------------
516# Strip executable binaries and shared object files
517#
518# Requires: find, awk, strip, cut, xargs
519#
520# Special macros which affect this process:
521#%no_install_post_strip 1 # disable stripping at all
522#%_noautostrip regexp # exclude files matching (anchored!) regex from stripping
523#%_autostripall regexp # strip files matching (anchored!) regex using plain strip
524#%_autostripunneeded regexp # strip files matching (anchored!) regex using strip --strip-unneeded
525#%_autostripdebug regexp # strip files matching (anchored!) regex using strip --strip-debug
526#
527%__spec_install_post_strip {%{!?debug: \
528%{!?no_install_post_strip:__spec_install_post_strip() { \
529if [ -d "$RPM_BUILD_ROOT" ]; then \
530 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
531 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
532 if [ "$modulelist" ]; then \
533 modulecount=$(echo "$modulelist" | wc -l); \
534 printf "Stripping %d kernel modules..." $modulecount; \
535 echo "$modulelist" | xargs -l512 chmod u+w; \
536 echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
537 echo "DONE"; \
538 fi; \
539 fi; \
540 filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
541 if [ -n "$filelist" ]; then \
542 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
543 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
544 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
545 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
546 if [ -n "$elfexelist" ]; then \
547 printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
548 chmod u+w $elfexelist; \
549 %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
550 echo "DONE"; \
551 fi; \
552 if [ -n "$elfsharedlist" ]; then \
553 printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
554 chmod u+w $elfsharedlist; \
555 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
556 echo "DONE"; \
557 fi; \
558 if [ -n "$archiveslist" ]; then \
559 printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
560 chmod u+w $archiveslist; \
561 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
562 echo "DONE"; \
563 fi; \
564 fi; \
565 filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
566 filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
567 filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
568 if [ -n "$filelist_all" ]; then \
569 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
570 chmod u+w $filelist_all; \
571 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
572 echo "DONE"; \
573 fi; \
574 if [ -n "$filelist_unneeded" ]; then \
575 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
576 chmod u+w $filelist_unneeded; \
577 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
578 echo "DONE"; \
579 fi; \
580 if [ -n "$filelist_debug" ]; then \
581 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
582 chmod u+w $filelist_debug; \
583 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
584 echo "DONE"; \
585 fi; \
586fi; }; __spec_install_post_strip } } }
587
588#-----------------------------------------------------------------
589# remove all RPATH from executable binaries and shared object files
590#
591# Requires: find, awk, cut, xargs, chrpath, uname
592#
593# Special macros which affect this process
594#%no_install_post_chrpath 1 # disable chrpath at all
595#%_noautochrpath regex # exclude files matching (anchored!) regex from chrpath
596#
597%__spec_install_post_chrpath {%{!?debug: \
598%{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
599if [ -d "$RPM_BUILD_ROOT" ]; then \
600 files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
601 if [ -n "$files" ]; then \
602 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
603 fi; \
604 if [ -n "$objs" ]; then \
605 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
606 echo "$objs" | \
607 while read file; do \
608 rpath= ; \
609 chmod u+w "$file"; \
610 for dir in $(chrpath -l "$file" | awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'); do \
611 case $dir in \
612 '$ORIGIN' ) \
613 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
614 else rpath="$rpath:$dir" ; fi ; \
615 continue ; \
616 ;; \
617 esac ; \
618 newdir=$(readlink -m "$dir"); \
619 [ ${#newdir} -le ${#dir} ] && dir=$newdir; \
620 case $dir in \
621 /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
622 echo "remove-rpath: $dir in $file"; \
623 ;; \
624 * ) \
625 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
626 else rpath="$rpath:$dir" ; fi ; \
627 ;; \
628 esac ; \
629 done ; \
630 if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
631 else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
632 done; \
633 fi; \
634fi; }; __spec_install_post_chrpath } } }
635
636# vim: "
637
638#-----------------------------------------------------------------
639# Find all shared object files with unresolved symbols. Warn
640# and terminate if any found (termination can be turned off by define).
641#%no_install_post_check_so 1
642%__spec_install_post_check_so { \
643 __spec_install_post_check_so() { \
644 fail=0; \
645 printf "Searching for shared objects with unresolved symbols..."; \
646 for f in $(find $RPM_BUILD_ROOT -type f -name '*.so.*' -print); do \
647 LC_ALL=C objdump -T $f 2> /dev/null | LC_ALL=C awk -v "file=$f" 'BEGIN { found=0; skip["program_name"]=1; symbols = "" } /^[0-9a-z]+ +D +\*UND\*/ { if ($NF in skip) { next; }; found = 1; symbols = symbols "\n\t" $NF } END { if (found) { print "\nUnresolved symbols found in: " file symbols; exit(1); } } ' || fail=1 ; \
648 done ; \
649 echo " DONE"; \
650 %{!?no_install_post_check_so:[ $fail -eq 1 ] && : || :;} \
651}; __spec_install_post_check_so }}
652
653#-----------------------------------------------------------------
654# Find and gzip all kernel modules
655#
656# Requires: find
657#
658#%no_install_post_compress_modules 1
659%__spec_install_post_compress_modules { \
660%{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
661 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
662 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
663 if [ "$q" ]; then \
664 printf "Compress %d kernel modules..." $(echo "$q" | wc -l); \
665 echo "$q" | xargs -r %{__gzip} -9nf; \
666 echo "DONE"; \
667 find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
668 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
669 fi; \
670 fi; \
671}; __spec_install_post_compress_modules } }
672
673# Remove common Perl files we don't package
674%__spec_install_post_perl_clean {\
675%{!?no_install_post_perl_clean: \
676%{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
677} }
678
679#-----------------------------------------------------------------
680# Update GConf2 schemas
681#
682# Requires: GConf2
683#
684%gconf_schema_install() \
685 umask 022; \
686 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
687 /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
688%{nil}
689
690%gconf_schema_uninstall() \
691if [ $1 = 0 -a -x /usr/bin/gconftool-2 ]; then \
692 umask 022; \
693 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
694 /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
695fi; \
696%{nil}
697
698#-----------------------------------------------------------------
699# Update desktop MIME database
700# requires: desktop-file-utils
701%update_desktop_database() {{ \
702 umask 022; \
703 /usr/bin/update-desktop-database -q; \
704};} \
705%{nil}
706
707%update_desktop_database_post %update_desktop_database
708
709%update_desktop_database_postun() {{ \
710if [ "$1" = "0" ]; then \
711 %update_desktop_database \
712fi; \
713};} \
714%{nil}
715
716#-----------------------------------------------------------------
717# Update shared MIME info database
718# requires: shared-mime-info
719#
720%update_mime_database() {{ \
721 umask 022; \
722 /usr/bin/update-mime-database %{_datadir}/mime; \
723};} \
724%{nil}
725
726#-----------------------------------------------------------------
727# Update icon cache
728# requires: gtk+
729#
730%update_icon_cache() {{ \
731 umask 022; \
732 /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
733};} \
734%{nil}
735
736#-----------------------------------------------------------------
737# Update scrollkeeper database
738# requires: scrollkeeper
739#
740%scrollkeeper_update_post() \
741 /usr/bin/scrollkeeper-update -q; \
742%{nil}
743
744%scrollkeeper_update_postun() \
745if [ "$1" = "0" ]; then \
746 /usr/bin/scrollkeeper-update -q; \
747fi; \
748%{nil}
749
750#-----------------------------------------------------------------
751# post %install sequence:
752# - autodeps exceptions
753# - compress all man and info pages,
754# - strip all ELF executables and ELF shared objects if not %debug.
755# - compress kernel modules if any
756
757###################################################################
758# Requires/Provides automation
759# exceptions system by Jacek Konieczny <jajcus@pld-linux.org>
760#
761%__noautoreqfiles %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
762%__noautoprovfiles %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
763%__noautoreq %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
764%__noautoreqdep %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
765%__noautoprov %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
766
767#%_noautocompressdoc %{nil}
768#
769%_missing_doc_files_terminate_build 1%{nil}
770%_unpackaged_files_terminate_build %{nil}
771# (X)emacs support
772%___emacs_lispdir_helper -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
773%_emacs_lispdir %{expand:%%global _emacs_lispdir %(Z=$(emacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_emacs_lispdir
774%_xemacs_lispdir %{expand:%%global _xemacs_lispdir %(Z=$(xemacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_xemacs_lispdir
775
776%__php_provides %{nil}
777%__php_requires %{nil}
778%__perl_provides %{nil}
779%__perl_requires %{nil}
780%__mono_provides %{nil}
781%__mono_requires %{nil}
782
783# Perl specific macro definitions.
784%perl_privlib %{expand:%%global perl_privlib %(eval $(%{__perl} -V:installprivlib 2>/dev/null); echo ${installprivlib:-ERROR})}%perl_privlib
785%perl_archlib %{expand:%%global perl_archlib %(eval $(%{__perl} -V:installarchlib 2>/dev/null); echo ${installarchlib:-ERROR})}%perl_archlib
786%perl_vendorlib %{expand:%%global perl_vendorlib %(eval $(%{__perl} -V:installvendorlib 2>/dev/null); echo ${installvendorlib:-ERROR})}%perl_vendorlib
787%perl_vendorarch %{expand:%%global perl_vendorarch %(eval $(%{__perl} -V:installvendorarch 2>/dev/null); echo ${installvendorarch:-ERROR})}%perl_vendorarch
788%perl_sitelib %{expand:%%global perl_sitelib %(eval $(%{__perl} -V:installsitelib 2>/dev/null); echo ${installsitelib:-ERROR})}%perl_sitelib
789%perl_sitearch %{expand:%%global perl_sitearch %(eval $(%{__perl} -V:installsitearch 2>/dev/null); echo ${installsitearch:-ERROR})}%perl_sitearch
790
791# Ruby
792%__ruby /usr/bin/ruby
793%ruby_archdir %{expand:%%global ruby_archdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)}%ruby_archdir
794%ruby_ridir %{expand:%%global ruby_ridir %(%{__ruby} -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)}%ruby_ridir
795%ruby_rubylibdir %{expand:%%global ruby_rubylibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)}%ruby_rubylibdir
796%ruby_vendorarchdir %{expand:%%global ruby_vendorarchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorarchdir
797%ruby_vendorlibdir %{expand:%%global ruby_vendorlibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorlibdir
798%ruby_sitearchdir %{expand:%%global ruby_sitearchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)}%ruby_sitearchdir
799%ruby_sitelibdir %{expand:%%global ruby_sitelibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)}%ruby_sitelibdir
800%ruby_rdocdir /usr/share/rdoc
801%ruby_version %{expand:%%global ruby_version %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)}%ruby_version
802%ruby_ver_requires_eq Requires: ruby(ver) = %ruby_version
803%ruby_mod_ver_requires_eq Requires: ruby-modules(ver) = %ruby_version
804
805%php_pear_dir /usr/share/pear
806%php_data_dir /usr/share/php
807%php_extensiondir %{expand:%%global php_extensiondir %(php-config --extension-dir 2>/dev/null || echo ERROR)}%php_extensiondir
808%php_sysconfdir %{expand:%%global php_sysconfdir %(php-config --sysconfdir 2>/dev/null || echo ERROR)}%php_sysconfdir
809%php_includedir %{expand:%%global php_includedir %(php-config --include-dir 2>/dev/null || echo ERROR)}%php_includedir
810
811# extract php/zend api versions
812%php_major_version %{expand:%%global php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_major_version
813%php_minor_version %{expand:%%global php_minor_version %(awk '/#define PHP_MINOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_minor_version
814%php_api_version %{expand:%%global php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)}%php_api_version
815%php_pdo_api_version %{expand:%%global php_pdo_api_version %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)}%php_pdo_api_version
816%php_debug %{expand:%%global php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)}%php_debug
817%zend_module_api %{expand:%%global zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)}%zend_module_api
818%zend_extension_api %{expand:%%global zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)}%zend_extension_api
819%_zend_zts %{expand:%%global _zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})}%_zend_zts
820# "_ts" if ZTS enabled, empty otherwise
821%zend_zts %{expand:%%global _zend_zts_%{?_zend_zts} 1}%{?_zend_zts_1:_ts}
822
823# helper macro
824%__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
825
826# macros for public use
827# for php extensions (php-pecl)
828%requires_php_extension %{__php_api_requires modules_api php_api_version} \
829%{__php_api_requires zend_module_api} \
830%{__php_api_requires -v %php_major_version debug php_debug} \
831%{__php_api_requires -v %php_major_version thread-safety _zend_zts}
832
833# for zend extensions
834%requires_zend_extension %{__php_api_requires zend_module_api} \
835%{__php_api_requires zend_extension_api} \
836%{__php_api_requires -v %php_major_version debug php_debug} \
837%{__php_api_requires -v %php_major_version thread-safety _zend_zts}
838
839# for php pdo modules (php-pecl-PDO_*)
840%requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
841
842# for using PHP post scripts. for PHP >= 5.0
843%php_webserver_restart \
844[ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
845[ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
846if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
847 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
848 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
849 %service -q php-fcgi restart \
850 fi \
851fi \
852if [ -x /etc/rc.d/init.d/php-fpm ]; then \
853 %service -q php-fpm restart \
854fi \
855%{nil}
856
857# for using php post scripts. for PHP >= 4.0 && PHP < 5.0
858%php4_webserver_restart \
859[ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
860[ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
861if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
862 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
863 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
864 %service -q php-fcgi restart \
865 fi \
866fi \
867%{nil}
868
869# X.org helper macros
870%__xorg_abi_requires_ge() Requires: xorg-xserver-server(%{expand:%1}-abi) >= %{expand:%{%2}}
871%__xorg_abi_requires_lt() Requires: xorg-xserver-server(%{expand:%1}-abi) < %(awk -vv=%{expand:%{%2}} 'BEGIN{split(v, a, "."); printf("%s.0", a[1] + 1); exit}')
872
873%xorg_xserver_ansic_abi %{expand:%%global xorg_xserver_ansic_abi %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_ansic_abi
874%xorg_xserver_extension_abi %{expand:%%global xorg_xserver_extension_abi %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_extension_abi
875%xorg_xserver_font_abi %{expand:%%global xorg_xserver_font_abi %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)}%xorg_xserver_font_abi
876%xorg_xserver_videodrv_abi %{expand:%%global xorg_xserver_videodrv_abi %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_videodrv_abi
877%xorg_xserver_xinput_abi %{expand:%%global xorg_xserver_xinput_abi %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_xinput_abi
878# vim: '
879
880%requires_xorg_xserver_extension \
881%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
882%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
883%{__xorg_abi_requires_ge extension xorg_xserver_extension_abi} \
884%{__xorg_abi_requires_lt extension xorg_xserver_extension_abi} \
885%{nil}
886
887%requires_xorg_xserver_xinput \
888%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
889%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
890%{__xorg_abi_requires_ge xinput xorg_xserver_xinput_abi} \
891%{__xorg_abi_requires_lt xinput xorg_xserver_xinput_abi} \
892%{nil}
893
894%requires_xorg_xserver_font \
895%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
896%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
897%{__xorg_abi_requires_ge font xorg_xserver_font_abi} \
898%{__xorg_abi_requires_lt font xorg_xserver_font_abi} \
899%{nil}
900
901%requires_xorg_xserver_videodrv \
902%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
903%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
904%{__xorg_abi_requires_ge videodrv xorg_xserver_videodrv_abi} \
905%{__xorg_abi_requires_lt videodrv xorg_xserver_videodrv_abi} \
906%{nil}
907
908# TCL specific macro definitions.
909# TODO: when th tcl is fixed use tclsh to get version: %(echo 'puts $tcl_version' | tclsh)
910%tcl_version %{expand:%%global tcl_version %(v=$(rpm -q --qf %{V} tcl | cut -d. -f1,2); echo ${v:-ERROR})}%tcl_version
911%tcl_sitearch %{_libdir}/tcl%{tcl_version}
912%tcl_sitelib %{_datadir}/tcl%{tcl_version}
913
914# Python specific macro definitions.
915# python main version
916%py_ver %{expand:%%global py_ver %(%{__python} -c "import sys; print sys.version[:3]" 2>/dev/null || echo ERROR)}%py_ver
917
918# directories
919%py_prefix %{expand:%%global py_prefix %(%{__python} -c "import sys; print sys.prefix" 2>/dev/null || echo ERROR)}%py_prefix
920%py_libdir %{py_prefix}/%{_lib}/python%{py_ver}
921%py_scriptdir %{py_prefix}/share/python%{py_ver}
922%py_incdir /usr/include/python%{py_ver}
923%py_sitedir %{py_libdir}/site-packages
924%py_sitescriptdir %{py_scriptdir}/site-packages
925%py_dyndir %{py_libdir}/lib-dynload
926
927# pure python modules compilation
928%py_comp python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
929
930%py_ocomp python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
931
932# Software written in Python language require Python with main version
933%pyrequires_eq() Requires: %1
934
935# Python 3.x
936# python main version
937%__python3 python3
938%py3_ver %{expand:%%global py3_ver %(%{__python3} -c "import sys; print(sys.version[:3])" 2>/dev/null || echo ERROR)}%py3_ver
939
940# directories
941%py3_prefix %{expand:%%global py3_prefix %(%{__python3} -c "import sys; print(sys.prefix)" 2>/dev/null || echo ERROR)}%py3_prefix
942%py3_libdir %{py3_prefix}/%{_lib}/python%{py3_ver}
943%py3_scriptdir %{py3_prefix}/share/python%{py3_ver}
944%py3_incdir /usr/include/python%{py3_ver}
945%py3_sitedir %{py3_libdir}/site-packages
946%py3_sitescriptdir %{py3_scriptdir}/site-packages
947%py3_dyndir %{py3_libdir}/lib-dynload
948
949# pure python modules compilation
950%py3_comp %{__python3} -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
951
952%py3_ocomp %{__python3} -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
953
954# Hardlink binary identical .pyc and .pyo files
955%__spec_install_post_py_hardlink {\
956%{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
957local a b c=0 t=0; \
958if [ -d "$RPM_BUILD_ROOT" ]; then \
959 find "$RPM_BUILD_ROOT" -name '*.pyc' > __rpm_pyc; \
960 while read a; do \
961 b="${a%.pyc}.pyo"; \
962 if cmp -s "$a" "$b"; then \
963 ln -f "$a" "$b"; \
964 c=$((c + 1)); \
965 fi; \
966 t=$((t + 1)); \
967 done < __rpm_pyc; \
968 [ $t -gt 0 ] && printf "Hardlink Python files: %d/%d files hardlinked\n" $c $t; \
969 rm -f __rpm_pyc; \
970fi; \
971}; __spec_install_post_py_hardlink } }
972
973# remove python sources, so that check-files won't complain
974%py_postclean() \
975for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
976 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
977done \
978%{nil}
979
980%py3_postclean() \
981for d in %{py3_sitescriptdir} %{py3_sitedir} %*; do \
982 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
983done \
984%{nil}
985
986# depmod macro
987%depmod() { \
988umask 022; \
989if [ -e /boot/System.map-%1 ]; then \
990 /sbin/depmod -a -F /boot/System.map-%1 %1; \
991else \
992 if [ -e /boot/System.map ]; then \
993 /sbin/depmod -a -F /boot/System.map %1; \
994 else \
995 /sbin/depmod -a %1; \
996 fi \
997fi; \
998}
999
1000# XMMS specific macros
1001%xmms_prefix %{expand:%%global xmms_prefix %(xmms-config --prefix 2>/dev/null || echo ERROR)}%xmms_prefix
1002%xmms_exec_prefix %{expand:%%global xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null || echo ERROR)}%xmms_exec_prefix
1003%xmms_version %{expand:%%global xmms_version %(xmms-config --version 2>/dev/null || echo ERROR)}%xmms_version
1004%xmms_datadir %{expand:%%global xmms_datadir %(xmms-config --data-dir 2>/dev/null || echo ERROR)}%xmms_datadir
1005%xmms_plugindir %{expand:%%global xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null || echo ERROR)}%xmms_plugindir
1006%xmms_visualization_plugindir %{expand:%%global xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null || echo ERROR)}%xmms_visualization_plugindir
1007%xmms_input_plugindir %{expand:%%global xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null || echo ERROR)}%xmms_input_plugindir
1008%xmms_output_plugindir %{expand:%%global xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null || echo ERROR)}%xmms_output_plugindir
1009%xmms_effect_plugindir %{expand:%%global xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null || echo ERROR)}%xmms_effect_plugindir
1010%xmms_general_plugindir %{expand:%%global xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null || echo ERROR)}%xmms_general_plugindir
1011
1012%_target_base_arch %{expand:%%global _target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/;s/sparcv./sparc/;s/arm.*/arm/')}%_target_base_arch
1013
1014# user/group checking macros
1015#
1016# Usage:
1017# %userremove myuser
1018#
1019%userremove /usr/lib/rpm/user_group.sh user del
1020%groupremove /usr/lib/rpm/user_group.sh group del
1021#
1022# Usage:
1023# if %usertestrm myuser; then
1024# /usr/sbin/userdel -r myuser
1025# Note:
1026# use these macros only if you need to call userdel/groupdel with
1027# a non-standard option or take an extra action; otherwise use the
1028# %userremove/%groupremove macros
1029#
1030%usertestrm /usr/lib/rpm/user_group.sh user testrm
1031%grouptestrm /usr/lib/rpm/user_group.sh group testrm
1032# user group membership management macros
1033#
1034# Usage:
1035# %addusertogroup [-q] myuser agroup
1036#
1037# -q if user or group don't exist, don't make big noise of it (MISSINGOK behaviour)
1038#
1039# Requirements:
1040# BuildRequires: rpmbuild(macros) >= 1.515
1041%addusertogroup(q) quiet=%{-q:1} /usr/lib/rpm/user_group.sh user addtogroup %*; \
1042%{nil}
1043
1044# banner support (useful in {pre,post}{,un} and triggers)
1045#
1046# Usage:
1047# %banner name [-a] [-e] [-n] [-tn] <<EOF
1048# the banner text, the banner text
1049# the banner text, and following line
1050#EOF
1051# You can use any form of here-document, <<'EOF' <<-EOT will do.
1052# NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
1053#
1054# -a - append to the banner
1055# -e - send to stderr instead of stdout
1056# -n - no show banner (overrides -t)
1057# -t - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
1058#
1059# Tests:
1060# (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
1061# rpm -E 'date | %banner -e banner' > m; sh -x m
1062#
1063%banner(aent:) ( \
1064RPM_SCRIPTVERBOSITY=5 \
1065[ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
1066if [ -x /usr/bin/banner.sh ]; then \
1067 CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
1068else \
1069 CMD="cat%{-e: >&2}" \
1070fi \
1071eval $CMD %{?2:%2}%{?3: %3}) \
1072%{nil}
1073
1074# useradd/groupadd macros
1075# Author: Elan Ruusamäe <glen@pld-linux.org>
1076#
1077# Usage:
1078# %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
1079# [-g initial_group] [-G group[,...]] login
1080#
1081# -u uid. REQUIRED
1082# -g gid/group. REQUIRED
1083# -s defaults to /bin/false
1084# -d defaults to /usr/share/empty
1085# -c No default
1086# -r is accepted but ignored (it's always set)
1087# -k skeleton dir. defaults to /usr/share/empty
1088# rpm specific flags
1089# -P package name. defaults to %{name}
1090#
1091%useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
1092%{!-u:%{error:useradd: Required argument -u missing}} \
1093%{!-g:%{error:useradd: Required argument -g missing}} \
1094%{!?1:%{error:useradd: Required parameter login missing}} \
1095if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
1096 if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
1097 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1098 exit 1 \
1099 fi \
1100else \
1101 echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
1102 /usr/sbin/useradd \\\
1103 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
1104 -u %{-u*} \\\
1105 -r \\\
1106 -d %{-d*}%{!-d:/usr/share/empty} \\\
1107 -s %{-s*}%{!-s:/bin/false} \\\
1108 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
1109 -g %{-g*} \\\
1110 %{-M} \\\
1111 %{-G:-G %{-G*}} \\\
1112 %{expand:%{%{#}}} 1>&2 || exit $? \
1113 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
1114fi;
1115# vim: "
1116
1117# Usage:
1118# %groupadd [-P package] [-g gid] group
1119#
1120# -g gid. REQUIRED
1121#
1122# Sample:
1123# %groupadd -P %{name}-base -g %{gid} %{name}
1124
1125%groupadd(g:P:rfo) \
1126%{!-g:%{error:groupadd: Required argument -g missing}} \
1127%{!?1:%{error:groupadd: Required parameter group missing}} \
1128if /usr/bin/getgid %{1} > /dev/null 2>&1; then \
1129 if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
1130 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1131 exit 1 \
1132 fi \
1133else \
1134 echo "Adding group %{1} GID=%{-g*}." \
1135 /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
1136 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
1137fi;
1138
1139# webapp macros
1140# Author: Elan Ruusamäe <glen@pld-linux.org>
1141#
1142# The config is installed/removed inside trigger, this means that you can any
1143# time install apache1/apache/lighttpd package and the configuration file is
1144# updated. if you don't need the config for various reason for specific
1145# webserver, just remove the symlink from config directory using webapp
1146# program. the trigger will not recreate the symlink on upgrades. In other
1147# words the config is linked to webserver config directory on first install of
1148# PACKAGE or WEBSERVER.
1149#
1150# Add package's webserver config to webserver webapps dir.
1151# Usage:
1152# %webapp_register [-f] WEBSERVER WEBAPP
1153#
1154%webapp_register(f) \
1155%{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
1156if [ -n "%{-f:1}" ] || [ "$1" = "1" ] && [ "$2" = "1" ]; then\
1157 /usr/sbin/webapp register %1 %2\
1158fi\
1159# reload webserver if the config symlink is there and skip reload if webserver is upgraded\
1160if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
1161 %{expand:%service -q %%1 reload}\
1162fi\
1163%{nil}
1164
1165# Remove package's config from webserver webapps dir.
1166# Usage:
1167# %webapp_register [-f] WEBSERVER WEBAPP
1168%webapp_unregister(f) \
1169%{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
1170# remove link if either of the packages are gone \
1171if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
1172 /usr/sbin/webapp unregister %1 %2\
1173 %{expand:%service -q %%1 reload}\
1174fi \
1175%{nil}
1176
1177# service macro.
1178# Author: Elan Ruusamäe <glen@pld-linux.org>
1179#
1180# calls usual service restart on package %post, but skips the restart if
1181# administrator has disabled automatic service restarts in either global
1182# /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
1183#
1184# Usage:
1185# %service [-q] [-n] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
1186#
1187# -q be silent when service isn't started (for scriplets restaring other package's services)
1188# -n NOOP mode, do not actually restart service
1189#
1190# Requirements:
1191# BuildRequires: rpmbuild(macros) >= 1.268
1192# Requires: rc-scripts
1193# -n option:
1194# BuildRequires: rpmbuild(macros) >= 1.450
1195%service(qn) {{%(export noop=%{-n:1} quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
1196
1197
1198# Java macros. based on jpackage macros.java
1199#
1200# Root directory where all Java VMs/SDK/JREs are installed.
1201%_jvmdir %{_libdir}/jvm
1202
1203# Root directory where all Java VMs/SDK/JREs expose their jars
1204%_jvmjardir %{_libdir}/jvm-exports
1205
1206# Root directory for all Java VM/SDK/JRE's private things.
1207%_jvmprivdir %{_libdir}/jvm-private
1208
1209# Root directory for all architecture dependent parts of Java VM/SDK/JRE's
1210%_jvmlibdir %{_libdir}/jvm
1211
1212# Root directory for all architecture independent parts of Java VM/SDK/JRE's
1213%_jvmdatadir %{_datadir}/jvm
1214
1215# Root directory for all configurations parts of Java VM/SDK/JRE's
1216%_jvmsysconfdir %{_sysconfdir}/jvm
1217
1218# Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
1219%_jvmcommonlibdir %{_libdir}/jvm-common
1220
1221# Root directory for all common architecture independent parts of Java VM/SDK/JRE's
1222%_jvmcommondatadir %{_datadir}/jvm-common
1223
1224# Root directory for all common configurations parts of Java VM/SDK/JRE's
1225%_jvmcommonsysconfdir %{_sysconfdir}/jvm-common
1226
1227# Directory where arch-specific (JNI) version-independent jars are installed.
1228%_jnidir %{_libdir}/java
1229
1230
1231# JDK selection. Set this to name of the JDK implementation to use
1232# insead of the system default
1233#%use_jdk icedtea6
1234
1235# expands to the value with right jdk for BuildRequires header
1236# 'jdk' if %%use_jdk is not defined, jdk(%%use_jdk) otherwise
1237# The requirement will not replace current 'default' JDK
1238%required_jdk jdk%{?use_jdk:(%{use_jdk})}
1239
1240%buildrequires_jdk BuildRequires: %required_jdk
1241
1242%java_home %{expand:%%global java_home %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; %{!?use_jdk:unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm}%{?use_jdk:JAVA_HOME=%{_jvmdir}/%{use_jdk}}; echo ${JAVA_HOME:-ERROR})}%java_home
1243
1244%_javasrcdir %{_usrsrc}/java
1245
1246%ant JAVA_HOME=%{java_home} CLASSPATH=$CLASSPATH ant
1247%jar %{java_home}/bin/jar
1248%java %{expand:%%global java %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; %{!?use_jdk:unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd}%{?use_jdk:JAVACMD=%{java_home}/bin/java}; echo $JAVACMD)}%java
1249%javac %{java_home}/bin/javac
1250%javadoc %{java_home}/bin/javadoc
1251
1252%add_jvm_extension JAVA_LIBDIR=%{buildroot}/%{_javadir} %{_bindir}/jvmjar -l
1253
1254%jpackage_script() \
1255install -d $RPM_BUILD_ROOT%{_bindir}\
1256cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
1257#!/bin/sh\
1258#\
1259# %{name} script\
1260# JPackage Project <http://www.jpackage.org/>\
1261\
1262# Source functions library\
1263. %{_javadir}-utils/java-functions\
1264\
1265# Source system prefs\
1266if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
1267 . %{_sysconfdir}/java/%{name}.conf\
1268fi\
1269\
1270# Source user prefs\
1271if [ -f $HOME/.%{name}rc ]; then\
1272 . $HOME/.%{name}rc\
1273fi\
1274\
1275# Configuration\
1276MAIN_CLASS=%1\
1277BASE_FLAGS=%2\
1278BASE_OPTIONS=%3\
1279BASE_JARS="%(echo %4 | tr ':' ' ')"\
1280\
1281# Set parameters\
1282set_jvm\
1283set_classpath $BASE_JARS\
1284set_flags $BASE_FLAGS\
1285set_options $BASE_OPTIONS\
1286\
1287# Let's start\
1288run "$@"\
1289EOF
1290
1291# jpackage 1.7
1292# Directory for maven depmaps
1293#
1294%_mavendepmapdir /etc/maven
1295%_mavendepmapfragdir /etc/maven/fragments
1296
1297#
1298# add_to_depmap adds an entry to the depmap. The arguments are:
1299#
1300# %1 the original groupid
1301# %2 the original artifact id
1302# %3 the version
1303# %4 the new groupid
1304# %5 the new artifactid
1305#
1306
1307%add_to_maven_depmap() \
1308install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1309cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1310<dependency>\
1311 <maven>\
1312 <groupId>%1</groupId>\
1313 <artifactId>%2</artifactId>\
1314 <version>%3</version>\
1315 </maven>\
1316 <jpp>\
1317 <groupId>%4</groupId>\
1318 <artifactId>%5</artifactId>\
1319 <version>%3</version>\
1320 </jpp>\
1321</dependency>\
1322\
1323EOF\
1324%{nil}
1325
1326#==============================================================================
1327#
1328# update_maven_depmap updates the main maven depmap
1329#
1330%update_maven_depmap() \
1331echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1332if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1333cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1334fi\
1335echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1336
1337# JAVA macros specific for PLD
1338
1339# Directory for tomcat context configuration files
1340%_tomcatconfdir %{_sharedstatedir}/tomcat/conf/Catalina/localhost
1341
1342# Tomcat cache path
1343%_tomcatcachedir %{_sharedstatedir}/tomcat/work/Catalina/localhost
1344
1345# Clear tomcat cache
1346# Author: Paweł Zuzelski <pawelz@pld-linux.org>
1347#
1348# Usage:
1349# %%tomcat_clear_cache appname
1350#
1351# Call this script in %postun scriptlet. It will remove compiled jsps related to
1352# given app.
1353#
1354%tomcat_clear_cache() %{!?1:ERROR}%{?2:ERROR} %{__rm} -rf %{_tomcatcachedir}/%1
1355
1356# PEAR install macros
1357# Author: Elan Ruusamäe <glen@pld-linux.org>
1358#
1359# Usage:
1360# %%pear_package_setup ...
1361#
1362# -a # - also unpack SOURCE#. for PEAR bootstrapping
1363# -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
1364# -z - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
1365# -D - pass -D to %setup (so the build dir is not removed)
1366# -c - register channel from local channel.xml file
1367# -d - pass -d arg to pearcmd
1368#
1369# unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1370# destination hierarchy. you should copy the tree to buildroot after
1371# patching/reorganizing with %%pear_package_install.
1372#
1373# additionally BUILDROOT is stripped from files and files are converted to UNIX
1374# line endings.
1375#
1376# the pear install process output is recorded to install.log, you should put it
1377# to %%doc for later debug or just for information.
1378#
1379# additionally additional-packages.txt is produced if it was detected that the
1380# package has optional dependencies. the file format is suitable of displaying
1381# in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1382# automatically added for this file.
1383
1384
1385# records install.log and transforms PEAR names to PLD Linux rpm package names.
1386%__pear_install_log \
1387tee install.log \
1388# make post message of optional packages \
1389grep -E 'can optionally use|Optional feature' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,;s,^pear/,php-pear-,;s,^channel://.*/,,' > optional-packages.txt \
1390if [ -s optional-packages.txt ]; then \
1391 awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1392else \
1393 rm -f optional-packages.txt \
1394fi \
1395%{nil}
1396
1397# Command invoking PEAR CLI
1398# Same as /usr/bin/pear, except we force GMT timezone
1399%__pear %__php -doutput_buffering=1 -dopen_basedir="" -dmemory_limit=-1 -ddate.timezone=GMT %{php_pear_dir}/pearcmd.php
1400
1401%pear_install(a:d:n:zD) \
1402%__pear \\\
1403 -c %{builddir}/pearrc \\\
1404 -d doc_dir=/docs \\\
1405 -d temp_dir=/tmp \\\
1406 -d php_dir=%{-c:%{builddir}/}%{php_pear_dir} \\\
1407 -d bin_dir=%{_bindir} \\\
1408 -d data_dir=%{php_pear_dir}/data \\\
1409 -d test_dir=%{php_pear_dir}/tests \\\
1410 %{-d:%(echo "%{-d*}" | awk 'BEGIN{RS=","}{printf("-d %%s \\\\\\n\\t", $1)}')} \\\
1411 install \\\
1412 --packagingroot=%{builddir} \\\
1413 --offline \\\
1414 --nodeps \\\
1415 %{-f:--force} \\\
1416 %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
1417 %{-c:cp -a %{builddir}/%{builddir}/%{php_pear_dir} %{builddir}/%(dirname %{php_pear_dir}); rm -rf %{builddir}/%{builddir}; } \
1418%{nil}
1419
1420# The main macro.
1421# using this macro will append optional-packages.txt to the nocompressdoc list
1422# as it's displayed to user after package install. and adding additional gzip
1423# dep is just waste ;)
1424%pear_package_setup(a:d:n:zDc:) \
1425%define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
1426%define builddir %{_builddir}/%{srcdir} \
1427%setup -q -c -T %{-D:-D} -n %{srcdir} \
1428%{-z:%{__tar} zxf %{S:0}; %{-a:%{__tar} zxf %{S:%{-a*}}}} \
1429%{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
1430%{-c:%{__pear} -c pearrc config-set php_dir %{builddir}/%{php_pear_dir}; %__pear -c %{builddir}/pearrc channel-add %{-c*}} \
1431%pear_install \
1432%{-z:cd ..} \
1433%{__tar} --wildcards -zvxf %{S:0} package*.xml \
1434cat %{-z:$_N/}.install.log | %__pear_install_log \
1435%undos -f php,html,js,xml \
1436%{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1437%{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1438%{nil}
1439
1440# Copies exctracted PEAR package structure and PEAR registry to buildroot.
1441# Author: Elan Ruusamäe <glen@pld-linux.org>
1442%pear_package_install() \
1443cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1444find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1445# help the developer out a little: \
1446if [ -f _noautoreq ]; then \
1447 echo "AutoReqdep detected:" \
1448 echo "_noautoreq $(cat _noautoreq)" \
1449fi \
1450%{nil}
1451
1452# Print optional package info for pear packages
1453# Author: Elan Ruusamäe <glen@pld-linux.org>
1454# Usage:
1455# %post -p <lua>
1456# %%pear_package_print_optionalpackages
1457#
1458# Requirements:
1459# BuildRequires: rpmbuild(macros) >= 1.571
1460%pear_package_print_optionalpackages \
1461f = io.open("%{_docdir}/%{name}-%{version}/optional-packages.txt", "r") \
1462if f then \
1463 for l in f:lines() do print(l); end \
1464end \
1465%{nil}
1466
1467
1468# Register OpenLDAP schema.
1469# Author: Elan Ruusamäe <glen@pld-linux.org>
1470#
1471# Usage:
1472# %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1473#
1474# -d specify dependant schemas, separated by comma
1475#
1476%openldap_schema_register(d:) \
1477for schema in %*; do \
1478 if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1479 %{__sed} -i -e " \
1480 /^include.*local.schema/{ \
1481 iinclude\\t $schema\
1482 } \
1483 " /etc/openldap/slapd.conf \
1484 fi \
1485done \
1486# enable dependant schemas \
1487if [ "%{-d*}" ]; then \
1488 %{__sed} -i -e ' \
1489 /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1490 s/^#// \
1491 }' /etc/openldap/slapd.conf \
1492fi \
1493%{nil}
1494
1495# Unregister OpenLDAP schema.
1496# Author: Elan Ruusamäe <glen@pld-linux.org>
1497#
1498# Usage:
1499# %%openldap_schema_unregister %{schemadir}/horde.schema
1500#
1501%openldap_schema_unregister() \
1502for schema in %*; do \
1503 if grep -q "$schema" /etc/openldap/slapd.conf; then \
1504 %{__sed} -i -e " \
1505 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1506 # for symmetry it would be nice if we disable enabled schemas in post, \
1507 # but we really can not do that, it would break something else. \
1508 " /etc/openldap/slapd.conf \
1509 fi \
1510done \
1511%{nil}
1512
1513%env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
1514
1515
1516# Build modules for kernels 2.6
1517# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1518#
1519# Usage:
1520# %build_kernel_modules -m <modules> -C <directory>
1521#
1522# remember that proper Makefile is still required
1523# Options:
1524# -m <modules> (required) -- comma-separated list of modules to save,
1525# without .ko extension, may be placed in subdirectory
1526# -C <directory> -- change to <directory> before doing anything
1527# -p <arg>, -P <arg> -- arguments passeed to make scripts
1528# -c -- do not execute make clean
1529# <additional arguments> -- all additional arguments will be passed to
1530# make modules
1531#
1532# Additional patching supported via here document. Try:
1533# %build_kernel_modules -m module <<'EOF'
1534# your patch script here
1535# EOF
1536# Don't use it unless patching depends on config options.
1537
1538# Developer note: don't touch it unless you know how to handle '\'.
1539# - \ in script expands to nothing
1540# - \\\ in script expands to \
1541# - \\\ inside definition expands to nothing
1542# - \\\\\\\ inside definition expands to \
1543# - in last line \ has to touch arguments so arguments passing
1544# in new lines (using \) will be supported
1545
1546%build_kernel_modules(p:P:m:C:c) \
1547%{!?-m:%{error:%{0}: Required module name/list missing} exit 1} \
1548 \
1549%define Opts \\\\\\\
1550%if "%{_target_base_arch}" != "%{_arch}" \\\
1551 %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386" \\\
1552 CC="%{kgcc}" ARCH=%{_target_base_arch} \\\
1553 %else \\\
1554 ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1555 %endif \\\
1556%else \\\
1557 CC="%{kgcc}" \\\
1558%endif \
1559%define MakeOpts HOSTCC="%{kgcc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
1560 O=$PWD/o %{?with_verbose:V=1} %{Opts} \
1561 \
1562%{?-C:cd %{-C*}} \
1563compile() { \
1564 local L="<" PATCH_SH; \
1565 [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)" \
1566 set -e -x \
1567 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1568 \
1569for cfg in ${cfgs:-dist}; do \
1570 [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1 \
1571 \
1572 rm -rf o \
1573 install -d o/include/linux o/include/generated o/arch/powerpc/lib \
1574 ln -sf %{_kernelsrcdir}/config-$cfg o/.config \
1575 ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers \
1576 if [ -f %{_kernelsrcdir}/include/generated/autoconf-$cfg.h ]; then \
1577 ln -sf %{_kernelsrcdir}/include/generated/autoconf-$cfg.h o/include/generated/autoconf.h \
1578 ln -s ../generated/autoconf.h o/include/linux/autoconf.h \
1579 else \
1580 ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1581 fi \
1582 \
1583 set +x \
1584 [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell \
1585 set -x \
1586 \
1587 %if %{with dist_kernel} || %(test -f %{_kernelsrcdir}/scripts/bin2c ; echo $?) \
1588 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts \\\
1589 %{-p*} %{-P*} \\\
1590 %{MakeOpts} \
1591 %else \
1592 install -d o/include/config \
1593 touch o/include/config/MARKER \
1594 ln -sf %{_kernelsrcdir}/include/config/auto-$cfg.conf o/include/config/auto.conf \
1595 ln -sf %{_kernelsrcdir}/scripts o/scripts \
1596 %endif \
1597 \
1598 %{!?-c:%{__make} -C %{_kernelsrcdir} clean \\\
1599 RCS_FIND_IGNORE="-name '*.ko' -o" \\\
1600 ${1+"$@"} \\\
1601 M=$PWD %{MakeOpts}} \
1602 \
1603 %{__make} -C %{_kernelsrcdir} modules \\\
1604 ${1+"$@"} \\\
1605 M=$PWD %{MakeOpts} \
1606 \
1607 for MODULE in {%{-m*},}; do \
1608 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko \
1609 done \
1610done \
1611%{?-C:cd -} \
1612} \
1613compile %{*}\
1614%{nil}
1615
1616
1617# Install kernel modules built by %build_kernel_modules
1618# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1619#
1620# Usage:
1621# %install_kernel_modules -m <modules> -d <directory>
1622#
1623# Options:
1624# -m <modules> (required) -- comma-separated list of modules to install,
1625# without .ko extension, may be placed in subdirectory
1626# -d <directory> (required) -- in what subdirectory modules should be
1627# installed (eg. misc, kernel/drivers/net)
1628# -s <suffix> -- suffix to use when installing modules, useful when module
1629# with same name exists in kernel already
1630# -n <file> -- name of modprobe config file to use (without .conf extension)
1631# for defining aliases, only useful with -s
1632
1633%install_kernel_modules(m:d:s:n:) \
1634%{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1} \
1635%{!?-d:%{error:%{0}: Required module directory missing}exit 1} \
1636%{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1637 \
1638%define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver} \
1639%define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
1640 \
1641__install_kernel_modules() { \
1642local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1643 \
1644for MODULE in {%{-m*},}; do \
1645 [ -n "${MODULE}" ] || continue \
1646 for cfg in ${cfgs:-dist}; do \
1647 [ "$cfg" = smp ] && suf=smp || suf= \
1648 MNAME=${MODULE##*/} \
1649 install -D ${MODULE}-$cfg.ko \\\
1650 %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko \
1651 %{?-s:install -d %{ModprobeD}$suf \
1652 echo "alias ${MNAME} ${MNAME}-%{-s*}" \\\
1653 >> %{ModprobeD}$suf/%{-n*}.conf} \
1654 done \
1655done \
1656} \
1657__install_kernel_modules \
1658%{nil}
1659
1660# patchset macros
1661# Author: Elan Ruusamäe <glen@pld-linux.org>
1662#
1663# Usage:
1664# %patchset_source -f <seq(1) format> <start> [<end>]
1665# %patchset_patch <start> [<end>]
1666#
1667# If <end> is omited, it is assumed to be <start>.
1668#
1669# For example in preamble:
1670# %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1671# and in %prep:
1672# %patchset_patch 33 44
1673
1674# generate SourceX urls from range START STOP
1675# Format can be SINGLE format char of %e, %f, %g, see seq(1)
1676# The sources start from 10000
1677%patchset_source(f:b:) %(
1678 base=%{-b*}%{!-b*:10000};
1679 start=$(expr $base + %1);
1680 end=$(expr $base + %{?2}%{!?2:%{1}});
1681 # we need to call seq twice as it doesn't allow two formats
1682 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1683 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1684 paste %{tmpdir}/__ps{1,2};
1685 rm -f %{tmpdir}/__ps{1,2};
1686) \
1687%{nil}
1688
1689# apply sources from %patchset_source
1690# -p specify -pX for %patch line
1691# -b base offset: defaults to 10000
1692%patchset_patch(f:p:b:) %(
1693 base=%{-b*}%{!-b*:10000};
1694 start=$(expr $base + %1);
1695 end=$(expr $base + %{?2}%{!?2:%{1}});
1696 echo ": patchset_patch %1%{?2: to %2}";
1697 seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
1698) \
1699%{nil}
1700
1701# browser plugins v2
1702# Author: Elan Ruusamäe <glen@pld-linux.org>
1703#
1704# Usage:
1705# %browser_plugins_add_browser <name> -p <plugindir>
1706#
1707# <name> (required) -- name of the browser. usually %{name}.
1708# -p <plugindir> (required) -- in what directory browser searches for its plugins.
1709# -b -- default blacklists
1710# -a <arch> override arch
1711#
1712# Example:
1713# %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1714
1715%_browserpluginsconfdir /etc/browser-plugins
1716%_browserpluginsdir %{_libdir}/browser-plugins
1717%update_browser_plugins /usr/sbin/update-browser-plugins || :
1718
1719%browser_plugins_add_browser(p:b:a:) \
1720 browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
1721 install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
1722 ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1723 blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
1724 echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1725 %{-b:cat >> $blacklist_file %{-b*}} \
1726%{nil}
1727
1728# Helper for LUA.
1729# split string separated by space into quoted list
1730#
1731# Author: Elan Ruusamäe <glen@pld-linux.org>
1732#
1733# %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1734%__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1735
1736# adjust /etc/shells by adding and removing shells from there
1737# Author: Elan Ruusamäe <glen@pld-linux.org>
1738#
1739# Usage:
1740# %post -p <lua>
1741# %lua_add_etc_shells /bin/sh /bin/pdksh
1742#
1743# %preun -p <lua>
1744# if arg[2] == 0 then
1745# %lua_remove_etc_shells /bin/bash /bin/rbash
1746# end
1747#
1748# Requirements:
1749# BuildRequires: rpmbuild(macros) >= 1.462
1750#
1751
1752%lua_add_etc_shells() \
1753t = {}\
1754f = io.open("/etc/shells", "r")\
1755if f then\
1756 for l in f:lines() do t[l]=l; end\
1757 f:close()\
1758end\
1759for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1760 if not t[s] then\
1761 print("Adding "..s.." to /etc/shells")\
1762 f = io.open("/etc/shells", "a"); f:write(s.."\\n"); f:close()\
1763 end\
1764end\
1765%{nil}
1766
1767%lua_remove_etc_shells() \
1768t = {}\
1769f = io.open("/etc/shells", "r")\
1770if f then\
1771 for l in f:lines() do t[l]=l; end\
1772 f:close()\
1773end\
1774for _, l in pairs({%{expand:%%__lua_split %*}}) do\
1775 print("Removing "..l.." from /etc/shells")\
1776 t[l] = nil\
1777end\
1778s=""\
1779for _, l in pairs(t) do\
1780 s=s..l.."\\n"\
1781end\
1782io.open("/etc/shells", "w"):write(s)\
1783%{nil}
1784
1785# Backwards compat. Use of %lua_ prefixed macros is preferred as these are cleaner to read.
1786#
1787# Author: Elan Ruusamäe <glen@pld-linux.org>
1788#
1789# Usage:
1790# %post -p %add_etc_shells -p /bin/sh /bin/pdksh
1791# %preun -p %remove_etc_shells -p /bin/sh /bin/pdksh
1792#
1793# -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
1794#
1795# Requirements:
1796# BuildRequires: rpmbuild(macros) >= 1.429
1797#
1798%add_etc_shells(p) %{-p:<lua>}\
1799%{expand:%%lua_add_etc_shells %*}\
1800%{nil}
1801
1802%remove_etc_shells(p) %{-p:<lua>}\
1803%{-p:if arg[2] == 0 then}\
1804%{expand:%%lua_remove_etc_shells %*}\
1805%{-p:end} \
1806%{nil}
1807
1808# Check syntax for Python files
1809#
1810# Author: Elan Ruusamäe <glen@pld-linux.org>
1811# Author: Arkadiusz Miśkiewicz <arekm@pld-linux.org>
1812#
1813# Usage:
1814# %py_lint src
1815#
1816# Requirements:
1817# BuildRequires: python
1818# BuildRequires: rpmbuild(macros) >= 1.469
1819
1820%py_lint() \
1821__py_lint() { \
1822find "$@" -type f -name '*.py' | python -c ' \
1823import sys \
1824import compiler \
1825\
1826err = 0\
1827for f in sys.stdin: \
1828 fd = open(f.strip()) \
1829 c = fd.read() \
1830 fd.close() \
1831 try: \
1832 compiler.parse(c) \
1833 except SyntaxError, e: \
1834 print "py_lint: %s: %s" % (f.strip(), e) \
1835 err = err + 1\
1836\
1837if err: \
1838 print >> sys.stderr, "\\npy_lint: ERROR: Syntax errors in %d files.\\n" % err \
1839 sys.exit(1) \
1840else: \
1841 print >> sys.stderr, "py_lint: Found no syntax errors." \
1842' \
1843}; __py_lint %* \
1844%{nil}
1845
1846# Undos files
1847#
1848# Author: Paweł Zuzelski <pawelz@pld-linux.org>
1849# Author: Elan Ruusamäe <glen@pld-linux.org>
1850#
1851# Usage:
1852# %undos list_of_files
1853# %undos -f EXT[,EXT]
1854# %undos -i -f EXT[,EXT]
1855#
1856# -f EXT[,EXT] - find(1) files by extensions
1857# -i - case insensitive file search
1858#
1859# Example:
1860# Un-DOS all *.js, *.css files
1861# %undos -f js,css
1862# Un-DOS all *.js, *.JS files
1863# %undos -f js -i
1864# undos all Makefiles
1865# %{__find} -name Makefile | xargs %undos
1866#
1867# Requirements:
1868# BuildRequires: sed >= 4.0
1869# BuildRequires: rpmbuild(macros) >= 1.565
1870
1871# NB: make sure this macro stays on one line
1872# NB: make sure it includes newline escape
1873%undos(f:i) %{-f:%{__find} -regextype posix-extended -%{-i:i}regex '^.+\\.(%(echo %{-f*} | tr ',' '|'))$' -print0 | xargs -0} %{__sed} -i -e 's,\\r$,,' %* \
1874%{nil}
1875
1876# Hook to register nagios object based plugins in Nagios NRPE daemon config.
1877#
1878# Author: Elan Ruusamäe <glen@pld-linux.org>
1879#
1880# Usage:
1881# -a NAME -- add command named NAME
1882# -d NAME -- remove command named NAME
1883# -f FILE -- specify plugin configuration FILE to extract command definition from
1884#
1885# Sample:
1886# %triggerin -- nagios-nrpe
1887# %nagios_nrpe -a %{plugin} -f %{_sysconfdir}/%{plugin}.cfg
1888#
1889# %triggerun -- nagios-nrpe
1890# %nagios_nrpe -d %{plugin} -f %{_sysconfdir}/%{plugin}.cfg
1891#
1892# Requirements:
1893# Requires: grep
1894# Requires: sed >= 4.0
1895# BuildRequires: rpmbuild(macros) >= 1.552
1896%nagios_nrpe(a:d:c:f:) {\
1897 m=$(md5sum < /etc/nagios/nrpe.cfg); \
1898 %{-a:# on -a and config exists \
1899 if [ -f /etc/nagios/nrpe.cfg ]; then \
1900 if ! %{__grep} -q '^command\[%{-a*}\]' /etc/nagios/nrpe.cfg; then \
1901 %{__sed} -ne 's/^[ \t]*command_line[ \t]\+\(.\+\)/command[%{-a*}]=\1/p' %{-f*} >> /etc/nagios/nrpe.cfg; \
1902 fi; \
1903 fi;} \
1904 %{-d:# on package remove, -d and config exists \
1905 if [ "$1" = "0" -a -f /etc/nagios/nrpe.cfg ]; then \
1906 %{__sed} -i -e '/^[ \t]*command\[%{-d*}\]/d' /etc/nagios/nrpe.cfg; \
1907 fi;} \
1908 if [ "$m" != "$(md5sum < /etc/nagios/nrpe.cfg)" ]; then \
1909 %service -q nrpe restart; \
1910 fi; \
1911}%{nil}
1912
1913# Import or update Cacti template.
1914#
1915# Author: Elan Ruusamäe <glen@pld-linux.org>
1916#
1917# Usage:
1918# %cacti_import_template XMLFILE
1919# XMLFILE -- XML template to import
1920#
1921# Sample:
1922# %post
1923# %cacti_import_template %{resourcedir}/cacti_host_template_varnish.xml
1924#
1925# Requires: cacti >= 0.8.7e-8
1926# BuildRequires: rpmbuild(macros) >= 1.554
1927
1928%cacti_import_template() {\
1929/usr/share/cacti/cli/import_template.php --filename=%1 || :; \
1930}%{nil}
1931
1932# pre/post script for -upstart subpackages
1933#
1934# Author: Jacek Konieczny <jajcus@jajcus.net>
1935#
1936# Usage:
1937# %upstart_post service_name
1938# %upstart_postun service_name
1939#
1940# Sample:
1941# %post upstart
1942# %upstart_post %{name}
1943#
1944# %postun upstart
1945# %upstart_postun %{name}
1946#
1947# Requirements:
1948# BuildRequires: rpmbuild(macros) >= 1.560
1949# Requires: rc-scripts >= 0.4.3
1950
1951# migrate from init script to upstart job
1952%upstart_post() \
1953 if [ -f /var/lock/subsys/"%1" ] ; then \
1954 /sbin/service --no-upstart "%1" stop \
1955 /sbin/service "%1" start \
1956 fi
1957
1958# restart the job after upgrade or migrate to init script on removal
1959# cannot be stopped with 'service' as /etc/init/$name.conf may be missing
1960# at this point
1961%upstart_postun() \
1962 if [ -x /sbin/initctl ] && /sbin/initctl status "%1" 2>/dev/null | grep -q 'running' ; then \
1963 /sbin/initctl stop "%1" >/dev/null 2>&1 \
1964 [ -f "/etc/rc.d/init.d/%1" -o -f "/etc/init/%1.conf" ] && { echo -n "Re-" ; /sbin/service "%1" start ; } ; \
1965 fi
1966
1967# vim:ts=4 sw=4 noet ft=spec
This page took 0.154852 seconds and 4 git commands to generate.